// DeviceInformation.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "DeviceInformation.h"
#include <windows.h>
#include <commctrl.h>
#include "sysctl.h"			// ǉ

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE			g_hInst;			// ݂̃C^[tFCX
#ifdef SHELL_AYGSHELL
HWND				g_hWndMenuBar;		// j[ o[ nh
#else // SHELL_AYGSHELL
HWND				g_hWndCommandBar;	// R}h o[ nh
#endif // SHELL_AYGSHELL
HMODULE				hSys;				// ǉ

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc	(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About	(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// AvP[V̏s܂:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_DEVICEINFORMATION));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_DEVICEINFORMATION));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI : CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// ^Cg o[ eLXg
    TCHAR szWindowClass[MAX_LOADSTRING];	// C EBhE NX

    g_hInst = hInstance; // O[oϐɃCX^Xi[܂B


    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_DEVICEINFORMATION, szWindowClass, MAX_LOADSTRING);


    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }


    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

#ifndef SHELL_AYGSHELL
    if (g_hWndCommandBar)
    {
        CommandBar_Show(g_hWndCommandBar, TRUE);
    }
#endif // !SHELL_AYGSHELL

    return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI :  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
    static SHACTIVATEINFO s_sai;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP
	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Iꂽj[̉:
            switch (wmId)
            {
                case IDM_HELP_ABOUT:
                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
                    break;
#ifndef SHELL_AYGSHELL
                case IDM_FILE_EXIT:
                    DestroyWindow(hWnd);
                    break;
#endif // !SHELL_AYGSHELL
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
#ifndef SHELL_AYGSHELL
            g_hWndCommandBar = CommandBar_Create(g_hInst, hWnd, 1);
            CommandBar_InsertMenubar(g_hWndCommandBar, g_hInst, IDR_MENU, 0);
            CommandBar_AddAdornments(g_hWndCommandBar, 0, 0);

			// ǉ@_CAO{bNX쐬܂B
			DialogBox(g_hInst, (LPCTSTR)IDD_DIALOG1, hWnd, DlgProc1);

#endif // !SHELL_AYGSHELL
            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: `R[hɒǉĂ...
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
#ifndef SHELL_AYGSHELL
            CommandBar_Destroy(g_hWndCommandBar);
#endif // !SHELL_AYGSHELL
            PostQuitMessage(0);
            break;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
        case WM_ACTIVATE:
            // bZ[W̃ANeBx[g shell ɒʒm܂B
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
            break;
        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP

        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
#ifndef SHELL_AYGSHELL
            RECT rectChild, rectParent;
            int DlgWidth, DlgHeight;	// sNZPʂł̃_CAO̕ƍłB
            int NewPosX, NewPosY;

            // o[W_CAO𒆉ɂ悤ƂĂ܂B
            if (GetWindowRect(hDlg, &rectChild)) 
            {
                GetClientRect(GetParent(hDlg), &rectParent);
                DlgWidth	= rectChild.right - rectChild.left;
                DlgHeight	= rectChild.bottom - rectChild.top ;
                NewPosX		= (rectParent.right - rectParent.left - DlgWidth) / 2;
                NewPosY		= (rectParent.bottom - rectParent.top - DlgHeight) / 2;
				
                // o[W{bNXʂ傫ꍇłB 
                if (NewPosX < 0) NewPosX = 0;
                if (NewPosY < 0) NewPosY = 0;
                SetWindowPos(hDlg, 0, NewPosX, NewPosY,
                    0, 0, SWP_NOZORDER | SWP_NOSIZE);
            }
#endif // !SHELL_AYGSHELL

            return (INT_PTR)TRUE;

        case WM_COMMAND:
#ifndef SHELL_AYGSHELL
            if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
#endif // !SHELL_AYGSHELL
            {
                EndDialog(hDlg, LOWORD(wParam));
                return (INT_PTR)TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return (INT_PTR)TRUE;

    }
    return (INT_PTR)FALSE;
}

// ǉ@_CAOvV[W
INT_PTR CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{	

	switch (msg) {
		case WM_INITDIALOG:
			RECT	rectChild, rectParent;
			int		DlgWidth, DlgHeight;
			POINT	NewPos;

			if (GetWindowRect(hDlg, &rectChild)) {
				GetClientRect(GetParent(hDlg), &rectParent);
				DlgWidth	= rectChild.right  - rectChild.left;
				DlgHeight	= rectChild.bottom - rectChild.top;
				NewPos.x	= (rectParent.right  - rectParent.left - DlgWidth) / 2;
				NewPos.y	= (rectParent.bottom - rectParent.top  - DlgHeight) / 2;

				SetWindowPos (hDlg, 0, NewPos.x, NewPos.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}

			TCHAR str[MAX_PATH];

			// VAԍ
			SysGetSerialNumber(str);
			if(str != NULL)
				SetDlgItemText(hDlg, IDC_SN, str);
			// \ԍ
			SysGetConfigNumber(str);
			if(str != NULL)
				SetDlgItemText(hDlg, IDC_CN, str);
			// foCX̌^
			SysGetModelName(str);
			if(str != NULL)
				SetDlgItemText(hDlg, IDC_MN, str);
			// VXe䃉Cũo[W
			SysGetLibraryVersion(str);
			if(str != NULL)
				SetDlgItemText(hDlg, IDC_LV, str);

			return (INT_PTR)TRUE;

		case WM_COMMAND:

			switch(LOWORD(wParam)) {
				case IDOK:
					break;

				default:
					break;
			}
			break;

		case WM_CLOSE:
			EndDialog(hDlg, LOWORD(wParam));
			SendMessage(GetParent(hDlg), WM_CLOSE, 0, 0);	// eEBhE閽߂𑗂܂B
			return (INT_PTR)TRUE;
	}
	return (INT_PTR)FALSE;
}
