// PowerSaveSettings.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "PowerSaveSettings.h"
#include <windows.h>
#include <commctrl.h>
#include "sysctl.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE			g_hInst;			// ݂̃C^[tFCX
HWND				g_hWndCommandBar;	// R}h o[ nh
TCHAR* Timeout_Batt[] = { L"POb", L"ROb", L"P", L"Q", L"R", L"S", L"T", L"Ȃ" };
TCHAR* Timeout_AC[]   = { L"P", L"Q", L"R", L"S", L"T", L"U", L"V", L"W", L"X", L"PO", L"Ȃ" };
TCHAR* Suspend_Batt[] = { L"P", L"Q", L"R", L"S", L"T", L"PO", L"RO", L"Ȃ" };
TCHAR* Suspend_AC[]   = { L"P", L"Q", L"T", L"PO", L"PT", L"RO", L"Ȃ" };

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
void ApplySettings(HWND g_hDlg);	// ǉ
void GetSettings(HWND g_Dlg);		// ǉ

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// AvP[V̏s܂:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_POWERSAVESETTINGS));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_POWERSAVESETTINGS));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI : CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// ^Cg o[ eLXg
    TCHAR szWindowClass[MAX_LOADSTRING];	// C EBhE NX

    g_hInst = hInstance; // O[oϐɃCX^Xi[܂B


    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_POWERSAVESETTINGS, szWindowClass, MAX_LOADSTRING);


    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }


    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    if (g_hWndCommandBar)
    {
        CommandBar_Show(g_hWndCommandBar, TRUE);
    }

    return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI :  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Iꂽj[̉:
            switch (wmId)
            {
                case IDM_HELP_ABOUT:
                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
                    break;
                case IDM_FILE_EXIT:
                    DestroyWindow(hWnd);
                    break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            g_hWndCommandBar = CommandBar_Create(g_hInst, hWnd, 1);
            CommandBar_InsertMenubar(g_hWndCommandBar, g_hInst, IDR_MENU, 0);
            CommandBar_AddAdornments(g_hWndCommandBar, 0, 0);

			// _CAO{bNX̍쐬
			DialogBox(g_hInst, (LPCTSTR)IDD_DIALOG1, hWnd, DlgProc1);

            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: `R[hɒǉĂ...
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndCommandBar);
            PostQuitMessage(0);
            break;


        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            RECT rectChild, rectParent;
            int DlgWidth, DlgHeight;	// sNZPʂł̃_CAO̕ƍłB
            int NewPosX, NewPosY;

            // o[W_CAO𒆉ɂ悤ƂĂ܂B
            if (GetWindowRect(hDlg, &rectChild)) 
            {
                GetClientRect(GetParent(hDlg), &rectParent);
                DlgWidth	= rectChild.right - rectChild.left;
                DlgHeight	= rectChild.bottom - rectChild.top ;
                NewPosX		= (rectParent.right - rectParent.left - DlgWidth) / 2;
                NewPosY		= (rectParent.bottom - rectParent.top - DlgHeight) / 2;
				
                // o[W{bNXʂ傫ꍇłB 
                if (NewPosX < 0) NewPosX = 0;
                if (NewPosY < 0) NewPosY = 0;
                SetWindowPos(hDlg, 0, NewPosX, NewPosY,
                    0, 0, SWP_NOZORDER | SWP_NOSIZE);
            }
            return (INT_PTR)TRUE;

        case WM_COMMAND:
            if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return TRUE;

    }
    return (INT_PTR)FALSE;
}

// _CAOvV[W
INT_PTR CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{	

	switch (msg) {
		case WM_INITDIALOG:
			RECT	rectChild, rectParent;
			int		DlgWidth, DlgHeight;
			POINT	NewPos;

			if (GetWindowRect(hDlg, &rectChild)) {
				GetClientRect(GetParent(hDlg), &rectParent);
				DlgWidth	= rectChild.right  - rectChild.left;
				DlgHeight	= rectChild.bottom - rectChild.top;
				NewPos.x	= (rectParent.right  - rectParent.left - DlgWidth) / 2;
				NewPos.y	= (rectParent.bottom - rectParent.top  - DlgHeight) / 2;

				SetWindowPos (hDlg, 0, NewPos.x, NewPos.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}

			int i;
			for(i=0; i<8; i++)
			{
				SendMessage(GetDlgItem(hDlg, IDC_COMBO_BKL_BATT), CB_INSERTSTRING, i, (LPARAM)Timeout_Batt[i]);
			}
			for(i=0; i<11; i++)
			{
				SendMessage(GetDlgItem(hDlg, IDC_COMBO_BKL_AC), CB_INSERTSTRING, i, (LPARAM)Timeout_AC[i]);
			}
			for(i=0; i<8; i++)
			{
				SendMessage(GetDlgItem(hDlg, IDC_COMBO_SUS_BATT), CB_INSERTSTRING, i, (LPARAM)Suspend_Batt[i]);
			}
			for(i=0; i<7; i++)
			{
				SendMessage(GetDlgItem(hDlg, IDC_COMBO_SUS_AC), CB_INSERTSTRING, i, (LPARAM)Suspend_AC[i]);
			}

			GetSettings(hDlg);

			return (INT_PTR)TRUE;

		case WM_COMMAND:

			switch(LOWORD(wParam)) {
				case IDOK:
					break;

				// uݒ擾v{^
				case IDC_BUTTON_GET:
					GetSettings(hDlg);
					break;
				// uݒv{^
				case IDC_BUTTON_APPLY:
					ApplySettings(hDlg);
					break;

				default:
					break;
			}
			break;

		case WM_CLOSE:
			EndDialog(hDlg, LOWORD(wParam));
			SendMessage(GetParent(hDlg), WM_CLOSE, 0, 0);	// eEBhE閽߂𑗂܂B
			return (INT_PTR)TRUE;
	}
	return (INT_PTR)FALSE;
}

// R{{bNXőIڂݒ肵܂B
void ApplySettings(HWND g_hDlg)
{
	switch (SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_GETCURSEL, 0, 0)) {
		case 0:
			SysSetBacklightTimeout(SYS_POWER_BATTERY_MODE, BACKLIGHT_TIMEOUT_TEN_SEC);
			break;
		case 1:
			SysSetBacklightTimeout(SYS_POWER_BATTERY_MODE, BACKLIGHT_TIMEOUT_THIRTY_SEC);
			break;
		case 2:
			SysSetBacklightTimeout(SYS_POWER_BATTERY_MODE, BACKLIGHT_TIMEOUT_ONE_MIN);
			break;
		case 3:
			SysSetBacklightTimeout(SYS_POWER_BATTERY_MODE, BACKLIGHT_TIMEOUT_TWO_MIN);
			break;
		case 4:
			SysSetBacklightTimeout(SYS_POWER_BATTERY_MODE, BACKLIGHT_TIMEOUT_THREE_MIN);
			break;
		case 5:
			SysSetBacklightTimeout(SYS_POWER_BATTERY_MODE, BACKLIGHT_TIMEOUT_FOUR_MIN);
			break;
		case 6:
			SysSetBacklightTimeout(SYS_POWER_BATTERY_MODE, BACKLIGHT_TIMEOUT_FIVE_MIN);
			break;
		case 7:
			SysSetBacklightTimeout(SYS_POWER_BATTERY_MODE, BACKLIGHT_TIMEOUT_INDEFINITELY);
			break;
		default:
			break;
	}

	switch (SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_GETCURSEL, 0, 0)) {
		case 0:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_ONE_MIN);
			break;
		case 1:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_TWO_MIN);
			break;
		case 2:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_THREE_MIN);
			break;
		case 3:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_FOUR_MIN);
			break;
		case 4:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_FIVE_MIN);
			break;
		case 5:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_SIX_MIN);
			break;
		case 6:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_SEVEN_MIN);
			break;
		case 7:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_EIGHT_MIN);
			break;
		case 8:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_NINE_MIN);
			break;
		case 9:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_TEN_MIN);
			break;
		case 10:
			SysSetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, BACKLIGHT_TIMEOUT_INDEFINITELY);
			break;
		default:
			break;
	}

	switch (SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_GETCURSEL, 0, 0)) {
		case 0:
			SysSetSuspendTime(SYS_POWER_BATTERY_MODE, SUSPEND_TIME_ONE_MIN);
			break;
		case 1:
			SysSetSuspendTime(SYS_POWER_BATTERY_MODE, SUSPEND_TIME_TWO_MIN);
			break;
		case 2:
			SysSetSuspendTime(SYS_POWER_BATTERY_MODE, SUSPEND_TIME_THREE_MIN);
			break;
		case 3:
			SysSetSuspendTime(SYS_POWER_BATTERY_MODE, SUSPEND_TIME_FOUR_MIN);
			break;
		case 4:
			SysSetSuspendTime(SYS_POWER_BATTERY_MODE, SUSPEND_TIME_FIVE_MIN);
			break;
		case 5:
			SysSetSuspendTime(SYS_POWER_BATTERY_MODE, SUSPEND_TIME_TEN_MIN);
			break;
		case 6:
			SysSetSuspendTime(SYS_POWER_BATTERY_MODE, SUSPEND_TIME_THIRTY_MIN);
			break;
		case 7:
			SysSetSuspendTime(SYS_POWER_BATTERY_MODE, SUSPEND_TIME_INDEFINITELY);
			break;
		default:
			break;
	}

	switch (SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_AC), CB_GETCURSEL, 0, 0)) {
		case 0:
			SysSetSuspendTime(SYS_POWER_EXTERNAL_MODE, SUSPEND_TIME_ONE_MIN);
			break;
		case 1:
			SysSetSuspendTime(SYS_POWER_EXTERNAL_MODE, SUSPEND_TIME_TWO_MIN);
			break;
		case 2:
			SysSetSuspendTime(SYS_POWER_EXTERNAL_MODE, SUSPEND_TIME_FIVE_MIN);
			break;
		case 3:
			SysSetSuspendTime(SYS_POWER_EXTERNAL_MODE, SUSPEND_TIME_TEN_MIN);
			break;
		case 4:
			SysSetSuspendTime(SYS_POWER_EXTERNAL_MODE, SUSPEND_TIME_FIFTEEN_MIN);
			break;
		case 5:
			SysSetSuspendTime(SYS_POWER_EXTERNAL_MODE, SUSPEND_TIME_THIRTY_MIN);
			break;
		case 6:
			SysSetSuspendTime(SYS_POWER_EXTERNAL_MODE, SUSPEND_TIME_INDEFINITELY);
			break;
		default:
			break;
	}
}


// ݂̐ݒ擾ăR{{bNXɕ\܂B
void GetSettings(HWND g_hDlg)
{
	DWORD time;

	SysGetBacklightTimeout(SYS_POWER_BATTERY_MODE, &time);
	switch (time) {
		case BACKLIGHT_TIMEOUT_TEN_SEC:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_SETCURSEL, (WPARAM)0, 0);
			break;
		case BACKLIGHT_TIMEOUT_THIRTY_SEC:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_SETCURSEL, (WPARAM)1, 0);
			break;
		case BACKLIGHT_TIMEOUT_ONE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_SETCURSEL, (WPARAM)2, 0);
			break;
		case BACKLIGHT_TIMEOUT_TWO_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_SETCURSEL, (WPARAM)3, 0);
			break;
		case BACKLIGHT_TIMEOUT_THREE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_SETCURSEL, (WPARAM)4, 0);
			break;
		case BACKLIGHT_TIMEOUT_FOUR_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_SETCURSEL, (WPARAM)5, 0);
			break;
		case BACKLIGHT_TIMEOUT_FIVE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_SETCURSEL, (WPARAM)6, 0);
			break;
		case BACKLIGHT_TIMEOUT_INDEFINITELY:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_BATT), CB_SETCURSEL, (WPARAM)7, 0);
			break;
		default:
			break;
	}

	SysGetBacklightTimeout(SYS_POWER_EXTERNAL_MODE, &time);
	switch (time) {
		case BACKLIGHT_TIMEOUT_ONE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)0, 0);
			break;
		case BACKLIGHT_TIMEOUT_TWO_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)1, 0);
			break;
		case BACKLIGHT_TIMEOUT_THREE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)2, 0);
			break;
		case BACKLIGHT_TIMEOUT_FOUR_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)3, 0);
			break;
		case BACKLIGHT_TIMEOUT_FIVE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)4, 0);
			break;
		case BACKLIGHT_TIMEOUT_SIX_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)5, 0);
			break;
		case BACKLIGHT_TIMEOUT_SEVEN_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)6, 0);
			break;
		case BACKLIGHT_TIMEOUT_EIGHT_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)7, 0);
			break;
		case BACKLIGHT_TIMEOUT_NINE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)8, 0);
			break;
		case BACKLIGHT_TIMEOUT_TEN_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)9, 0);
			break;
		case BACKLIGHT_TIMEOUT_INDEFINITELY:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_BKL_AC), CB_SETCURSEL, (WPARAM)10, 0);
			break;
		default:
			break;
	}

	SysGetSuspendTime(SYS_POWER_BATTERY_MODE, &time);
	switch (time) {
		case SUSPEND_TIME_ONE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_SETCURSEL, (WPARAM)0, 0);
			break;
		case SUSPEND_TIME_TWO_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_SETCURSEL, (WPARAM)1, 0);
			break;
		case SUSPEND_TIME_THREE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_SETCURSEL, (WPARAM)2, 0);
			break;
		case SUSPEND_TIME_FOUR_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_SETCURSEL, (WPARAM)3, 0);
			break;
		case SUSPEND_TIME_FIVE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_SETCURSEL, (WPARAM)4, 0);
			break;
		case SUSPEND_TIME_TEN_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_SETCURSEL, (WPARAM)5, 0);
			break;
		case SUSPEND_TIME_THIRTY_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_SETCURSEL, (WPARAM)6, 0);
			break;
		case SUSPEND_TIME_INDEFINITELY:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_BATT), CB_SETCURSEL, (WPARAM)7, 0);
			break;
		default:
			break;
	}

	SysGetSuspendTime(SYS_POWER_EXTERNAL_MODE, &time);
	switch (time) {
		case SUSPEND_TIME_ONE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_AC), CB_SETCURSEL, (WPARAM)0, 0);
			break;
		case SUSPEND_TIME_TWO_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_AC), CB_SETCURSEL, (WPARAM)1, 0);
			break;
		case SUSPEND_TIME_FIVE_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_AC), CB_SETCURSEL, (WPARAM)2, 0);
			break;
		case SUSPEND_TIME_TEN_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_AC), CB_SETCURSEL, (WPARAM)3, 0);
			break;
		case SUSPEND_TIME_FIFTEEN_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_AC), CB_SETCURSEL, (WPARAM)4, 0);
			break;
		case SUSPEND_TIME_THIRTY_MIN:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_AC), CB_SETCURSEL, (WPARAM)5, 0);
			break;
		case SUSPEND_TIME_INDEFINITELY:
			SendMessage(GetDlgItem(g_hDlg, IDC_COMBO_SUS_AC), CB_SETCURSEL, (WPARAM)6, 0);
			break;
		default:
			break;
	}
}